Can I Win

Game Theory, Minimax, Memorized Search, Dynamic Programming

Medium

In the "100 game," two players take turns adding, to a running total, any integer from 1..10. The player who first causes the running total to reach or exceed 100 wins.

What if we change the game so that players cannot re-use integers?

For example, two players might take turns drawing from a common pool of numbers of 1..15 without replacement until they reach a total >= 100.

Given an integermaxChoosableIntegerand another integerdesiredTotal, determine if the first player to move can force a win, assuming both players play optimally.

You can always assume thatmaxChoosableIntegerwill not be larger than 20 anddesiredTotalwill not be larger than 300.

Example

Input:

maxChoosableInteger = 10
desiredTotal = 11


Output:

false


Explanation:

No matter which integer the first player choose, the first player will lose.
The first player can choose an integer from 1 up to 10.
If the first player choose 1, the second player can only choose integers from 2 up to 10.
The second player will win by choosing 10 and get a total = 11, which is 
>
= desiredTotal.
Same with other integers chosen by the first player, the second player will always win.

Solution & Analysis

题意:给了我们一堆数字,然后两个人轮流,每人每次选一个数字,看两个人所有选取的数字总和,如果达到或超过给定值,则当前这一轮的玩家获胜。问在两个玩家都很聪明地选择最优方法时,player 1是否一定能赢。

对于player 1来说,是否一定能赢,就是说明是否存在某一种取法,让player 2在每一步都无法取胜。这里寻找所有的排列组合就需要用到递归了。Top-down DP。

但是如果不记忆中间结果,那么搜索树就会是 O(n * (n - 1) * (n - 2) ... 2 * 1) ~ O(n!) 的时间和空间复杂度。需要记忆化,那么这个hashmap用什么作为key呢?

对于每一个选手来说,当前台面上的已选择数字只跟总和有关,而顺序无关,因此有许多重复的状态可以在搜索时剪枝。一个合理的方式就是将数字对应的boolean[]数组标记为true/false,再用Arrays.toString()转化为一个String key。还可以进一步优化hashmap 的key,因为备选数字从1 ~ n,因此可以直接对应integer的二进制表示,比如

boolean[] {false, false, true, true, false}, to integer with binary representation as00110.

--

Adapted from: https://leetcode.com/problems/can-i-win/discuss/95277/Java-solution-using-HashMap-with-detailed-explanation

By @leogogogo:

Most of the "Game Playing" problems on LeetCode can be solved using the top-down DP approach, which "brute-forcely" simulates every possible state of the game.

The key part for the top-down dp strategy is that we need to avoid repeatedly solving sub-problems. Instead, we should use some strategy to "remember" the outcome of sub-problems. Then when we see them again, we instantly know their result.

-

For this question, the key part is:what is the state of the game? Intuitively, to uniquely determine the result of any state, we need to know:

  1. The unchosen numbers

  2. The remaining desiredTotal to reach

A second thought reveals that1)and2)are actually related because we can always get the2)by deducting the sum of chosen numbers from original desiredTotal.

Then the problem becomes how to describe the state using1).

Since in the problem statement, it saysmaxChoosableIntegerwill not be larger than20, which means the length of our boolean[] array will be less than20. Then we can use anIntegerto represent this boolean[] array. How?

Say the boolean[] is{false, false, true, true, false}, then we can transfer it to an Integer with binary representation as00110. Since Integer is a perfect choice to be the key of HashMap, then we now can "memorize" the sub-problems usingMap<Integer, Boolean>.

The rest part of the solution is just simulating the game process using the top-down dp.

-

Time Complexity:

Thanks @billbirdh for pointing out the mistake here. For this problem, by applying the memo, we at most compute for every subproblem once, and there are O(2^n) subproblems, so the complexity is O(2^n) after memorization. (Without memo, time complexity should be like O(n!))

Space Complexity:

O(2^n)

class Solution {
    public boolean canIWin(int maxChoosableInteger, int desiredTotal) {
        int sum = maxChoosableInteger * (maxChoosableInteger + 1) / 2;
        if (sum < desiredTotal) {
            return false;
        }
        if (desiredTotal <= maxChoosableInteger) {
            return true;
        }
        Map<Integer, Boolean> memo = new HashMap<Integer, Boolean>();
        boolean[] used = new boolean[maxChoosableInteger + 1];
        return helper(desiredTotal, memo, used);
    }

    private boolean helper(int desiredTotal, Map<Integer, Boolean> memo, boolean[] used) {
        if (desiredTotal <= 0) {
            return false;
        }
        int key = formatKey(used);
        if (!memo.containsKey(key)) {

            // try every unchosen number as next step
            for (int i = 1; i < used.length; i++) {
                if (!used[i]) {
                    used[i] = true;

                    // check whether this lead to a win (i.e. the other player lose)
                    if (!helper(desiredTotal - i, memo, used)) {
                        memo.put(key, true);
                        used[i] = false;
                        return true;
                    }
                    used[i] = false;
                }
            }
            memo.put(key, false);
        }
        return memo.get(key);

    }

    private int formatKey(boolean[] used) {
        int key = 0;
        for (boolean b: used) {
            key = key << 1;
            if (b) {
                key = key | 1;
            }
        }
        return key;
    }
}

Reference

Huahua's Tech Road: http://zxi.mytechroad.com/blog/searching/leetcode-464-can-i-win/

Grandyang: https://www.cnblogs.com/grandyang/p/6103525.html

lightwindy: https://www.cnblogs.com/lightwindy/p/9736348.html

Last updated